import wizard
import sql_db
import netsvc
import math
from osv import osv
from tools.misc import UpdateableStr

def _is_pair(x):
	return not x%2

def _get_ean_key(string):
	if not string or string=='':
		return '0'
	if len(string)!=12:
		return '0'
	sum=0
	for i in range(12):
		if _is_pair(i):
	 		sum+=int(string[i])
		else:
			sum+=3*int(string[i])
	return str(int(math.ceil(sum/10.0)*10-sum))

_check_arch = UpdateableStr()

_check_fields = {}

def _check_key(wizard,uid,datas):
	cr = sql_db.db.cursor()
	partner_table=osv.osv_pools.get('res.partner')
	partners = partner_table.browse(cr, uid, datas['ids'])
	_check_arch_lst=['<?xml version="1.0"?>', '<form title="Check EAN13">', '<label string=""/>', '<label string=""/>','<label string="Original" />', '<label string="Computed" />']
	for partner in partners:
		if partner['ean13'] and len(partner['ean13'])>11 and len(partner['ean13'])<14:
			_check_arch_lst.append('<label colspan="2" string="%s" />' % partner['ean13']);
			key=_get_ean_key(partner['ean13'][:12])
			_check_arch_lst.append('<label string=""/>')
			if len(partner['ean13'])==12:
				_check_arch_lst.append('<label string="" />');
			else:
				_check_arch_lst.append('<label string="%s" />' % partner['ean13'][12])
			_check_arch_lst.append('<label string="%s" />' % key)
	_check_arch_lst.append('</form>')
	_check_arch.string = '\n'.join(_check_arch_lst)
	cr.close()
	return {}

def _update_ean(wizard, uid, datas):
	cr = sql_db.db.cursor()
	partner_table=osv.osv_pools.get('res.partner')
	partners = partner_table.browse(cr, uid, datas['ids'])
	for partner in partners:
		partner_table.write(cr, uid, datas['ids'], { 'ean13' : "%s%s" % ( partner['ean13'][:12] , _get_ean_key(partner['ean13'][:12]) ) })
	cr.commit()
	cr.close()
	return {}

class wiz_ean_check(wizard.interface):
	states = {	'init': {		'actions': [_check_key],
								'result': {	'type': 'form',
											'arch': _check_arch,
											'fields': _check_fields,
											'state': (('correct', 'Correct EAN13'), ('end', 'Ignore'))
										}
						},
				'correct' : {	'actions': [_update_ean],
								'result': {	'type': 'state',
											'state' : 'end'
										}
							}
			}

wiz_ean_check('res.partner.ean13')
